.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;**********************************************************************************************************

IDB_PIC1        equ 801
IDB_PIC2        equ 802
IDB_MASK        equ 803

;**********************************************************************************************************

.data
AppName     db "Masking",0
ClassName   db "Masko",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hBmp1       HBITMAP     ?       ;background
hBmp2       HBITMAP     ?       ;image
hBmp3       HBITMAP     ?       ;image's mask

hDCBmp1     HDC         ?
hDCBmp2     HDC         ?
hDCBmp3     HDC         ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov eax,hInstance
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET ClassName
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,200,200,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        .WHILE TRUE
            invoke GetMessage, ADDR msg,NULL,0,0
            .BREAK .IF(!eax)
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage, ADDR msg
        .ENDW
        mov eax,msg.wParam
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL ps:PAINTSTRUCT
    LOCAL hDC:HDC
    mov eax,uMsg
;-- WM_PAINT ----------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        invoke BeginPaint, hwnd,ADDR ps
        mov hDC,eax

        ;draw some background
        invoke BitBlt, hDC,0,0,128,128,hDCBmp1,0,0,SRCCOPY

        ;draw the mask - to remove the background pixels we don't want
        invoke BitBlt, hDC,30,30,64,64,hDCBmp3,0,0,SRCAND

        ;now draw our actual image
        invoke BitBlt, hDC,30,30,64,64,hDCBmp2,0,0,SRCPAINT


        invoke EndPaint, hwnd,ADDR ps
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke LoadBitmap, hInstance,IDB_PIC1
        mov hBmp1,eax
        invoke LoadBitmap, hInstance,IDB_PIC2
        mov hBmp2,eax
        invoke LoadBitmap, hInstance,IDB_MASK
        mov hBmp3,eax

        push ebx
        invoke GetDC, hwnd
        mov ebx,eax

        ;dc for background
        invoke CreateCompatibleDC, ebx
        mov hDCBmp1,eax
        invoke SelectObject, hDCBmp1,hBmp1

        ;dc for image
        invoke CreateCompatibleDC, ebx
        mov hDCBmp2,eax
        invoke SelectObject, hDCBmp2,hBmp2

        ;dc for mask
        invoke CreateCompatibleDC, ebx
        mov hDCBmp3,eax
        invoke SelectObject, hDCBmp3,hBmp3

        invoke ReleaseDC, hwnd,ebx
        pop ebx

;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke DeleteDC, hDCBmp1
        invoke DeleteDC, hDCBmp2
        invoke DeleteDC, hDCBmp3
        invoke DeleteObject, hBmp1
        invoke DeleteObject, hBmp2
        invoke DeleteObject, hBmp3
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
